# Import all nesseccary Modules and Classes from PyQt4 and QGIS
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import QgsFeature,  QgsMapLayerRegistry
import base64

# Define some global variables
imageField = None
imagePreview = None
toolButton = None
fileName = None

# This is the main function which will be connected with the QGIS layer
def formOpen( dialog, layer, featureid ):

    global imageField
    global imagePreview
    global toolButton
        
    imageField = dialog.findChild( QTextEdit, "image" )
    imagePreview = dialog.findChild( QTextEdit, "imagePreview" )

# Find the QToolButton Object to connect the conversion function. 
    toolButton = dialog.findChild( QToolButton, "toolButton" )

# When the ToolButton is clicked run the method getFileName()
    toolButton.clicked.connect(getFileName)

# set the imageField Widget invisible for a nicer GUI. It is not nesseccary to see the data
    imageField.setVisible(False)
    imagePreview.setText('<img width="300" src="data:image/jpg;base64,'+imageField.toPlainText()+'"/>')


# Open FileDialog and convert the binary image to base64 
def getFileName():
    filePath = QFileDialog.getOpenFileName(None,  'Open Image File',  '',  '(Images *.jpg *.png)')

    if len(filePath) > 0:
      encodedImage = ''
    
# Read the image file and proceed the encoding
      encodedImage = base64.b64encode(open(filePath, 'rt').read())

# Set the appropriate fields for storing in the QGIS layer
      imageField.setPlainText(encodedImage)
      
# Set HTML img tag around the base64 image
      imagePreview.setText('<img width="300" src="data:image/jpg;base64,'+encodedImage+'"/>')


        
    
